<?php
/**
 * @package captiva
 */
?>
<div class="row animate" data-animate="fadeIn">
    <article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
        <?php if ( has_post_format( 'chat' ) ) : ?>
            <!-- don't display thumbnail -->
        <?php elseif ( has_post_format( 'gallery' ) ) : ?>
            <!-- don't display thumbnail -->
        <?php elseif ( has_post_format( 'link' ) ) : ?>
            <!-- don't display thumbnail -->
        <?php elseif ( has_post_format( 'quote' ) ) : ?>
            <!-- don't display thumbnail -->
        <?php elseif ( has_post_format( 'status' ) ) : ?>
            <!-- don't display thumbnail -->
        <?php elseif ( has_post_format( 'image' ) ) : ?>
            <!-- don't display thumbnail -->
        <?php elseif ( has_post_format( 'aside' ) ) : ?>
        <?php else : ?>
            <!-- display it -->
            <?php if ( has_post_thumbnail() ) : ?>
                <div class="image">
                    <a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>" >
                        <?php the_post_thumbnail(); ?>
                    </a>
                </div>
            <?php endif; ?>
        <?php endif; ?>
        <header class="entry-header">
            <h2 class="entry-title"><a href="<?php the_permalink(); ?>" rel="bookmark"><?php the_title(); ?></a></h2>	
            <?php if ( 'post' == get_post_type() ) : ?>
                <div class="entry-meta">
                    <?php captiva_posted_on(); ?>
                </div><!-- .entry-meta -->
            <?php endif; ?>
        </header><!-- .entry-header -->
        <?php if ( is_search() ) : // Only display Excerpts for Search ?>
            <div class="entry-summary">
                <?php the_excerpt(); ?>
            </div><!-- .entry-summary -->
        <?php else : ?>
            <div class="entry-content">
                <?php
                the_content( __( 'Read more', 'captiva' ) );
                wp_link_pages( array(
                    'before' => '<div class="page-links"><span class="page-links-title">' . __( 'Pages:', 'captiva' ) . '</span>',
                    'after' => '</div>',
                    'link_before' => '<span>',
                    'link_after' => '</span>',
                ) );
                ?>
            </div><!-- .entry-content -->
        <?php endif; ?>
        <footer class="entry-meta">
            <?php if ( 'post' == get_post_type() ) : // Hide category and tag text for pages on Search ?>
                <?php
                /* translators: used between list items, there is a space after the comma */
                $categories_list = get_the_category_list( __( ', ', 'captiva' ) );
                if ( $categories_list && captiva_categorized_blog() ) :
                    ?>
                    <span class="cat-links">
                        <?php printf( __( 'Posted in %1$s', 'captiva' ), $categories_list ); ?>
                    </span>
                <?php endif; // End if categories ?>

                <?php
                /* translators: used between list items, there is a space after the comma */
                $tags_list = get_the_tag_list( '', __( ', ', 'captiva' ) );
                if ( $tags_list ) :
                    ?>
                    <span class="tags-links">
                        <?php // printf( __( 'Tagged %1$s', 'captiva' ), $tags_list ); ?>
                    </span>
                <?php endif; // End if $tags_list ?>
            <?php endif; // End if 'post' == get_post_type() ?>

            <?php if ( !post_password_required() && ( comments_open() || '0' != get_comments_number() ) ) : ?>
                <span class="comments-link"><?php comments_popup_link( __( 'Leave a comment', 'captiva' ), __( '1 Comment', 'captiva' ), __( '% Comments', 'captiva' ) ); ?></span>
            <?php endif; ?>

            <?php edit_post_link( __( 'Edit', 'captiva' ), '<span class="edit-link">', '</span>' ); ?>
        </footer><!-- .entry-meta -->
    </article><!-- #post-## -->
</div>